# -*- coding: cp1251 -*-
import urllib, os

def str_btw ( s, ps1, ps2 ) :
    pos1 = s.find(ps1)
    if pos1>-1 and len(ps2)==0 :
        return s[pos1+len(ps1):]
    pos2 = s.find(ps2, pos1+1)
    if pos1>-1 and pos2>-1 and pos2>pos1 :
        return s[pos1+len(ps1):pos2]
    else :
        return ""

def save_file( s, filename) :
    f = open(filename,"wb")
    f.write(s)
    f.close()

def load_file( filename) :
    f = open(filename,"rb")
    s = f.read()
    f.close()
    return s

HLD_SEPARATOR = "</tr><tr><td class=\"yfnc_tabledata1\">"

#    
f = open("yahoo_top.csv","rt")
ls = f.read().splitlines()
f.close()

f_out = open("yahoo_ih.csv","wt")
f_out.write("Ticker,Holder,Shares,%,Value,Reported\n")
l_comp = []
for i in range(501) :
    lc = ls[i].split(";")
    fn = lc[0]+".html"
    if os.path.exists(fn) :
        s = load_file(fn)
    else :
        s = urllib.urlopen("http://finance.yahoo.com/q/mh?s="+lc[0]).read()
        save_file(s, fn)
    #    
    pos_tih = s.find("<b>TOP INSTITUTIONAL HOLDERS</b>")
    pos_tmh = s.find("<b>TOP MUTUAL FUND HOLDERS</b>")
    pos_r = pos_tih
    pos_r = s.find(HLD_SEPARATOR, pos_r+len(HLD_SEPARATOR))
    while pos_r > -1 and pos_r < pos_tmh :
        pos_re = s.find("</tr>", pos_r+len(HLD_SEPARATOR))
        lt = s[pos_r+9 : pos_re].split("</td>")
        f_out.write(lc[0])
        lr = [lc[0]]
        for t in lt :
            ct = str_btw(t,">","").replace(",","")
            f_out.write("," + ct )
            lr.append(ct)
        f_out.write("\n")
        #    
        lr.append(lc[1].replace(",","."))
        l_comp.append(lr)
        pos_r = s.find("</tr><tr><td class=\"yfnc_tabledata1\">", pos_r+len(HLD_SEPARATOR))

f_out.close()

#  l_comp:    -10    
#   $  :
d_hold = {}
for c in l_comp :
    d_hold[ (c[0], c[1]) ] = ( int(c[4][1:]), float(c[3]) )
#      -10 
l_comp.sort(lambda x,y: cmp(x[1],y[1]))

l_hold = []
ch = l_comp[0][1]
cs = 0
for c in l_comp :
    if c[1] <> ch :
        #  ,  
        l_hold .append((ch,cs))
        ch = c[1]
        cs = 0
    else :
        cs = cs + d_hold[ (c[0], c[1]) ][0]
#  
l_hold.append((ch,cs))

l_hold.sort(lambda x,y: cmp(x[1],y[1]))
l_hold.reverse()
l_hld = []
for ch in l_hold[:10] :
    l_hld.append(ch[0])

#         
l_comp.sort(lambda x,y: cmp(x[0],y[0]))

l_res = []
cc = l_comp[0][0]
cv = float(l_comp[0][7])
cs = 0
for c in l_comp :
    if c[0] <> cc :
        #  ,    
        l_res.append((cc,cv,cs))
        cc = c[0]
        cv = float(c[7])
        cs = 0
    else :
        if c[1] in l_hld :
            cs = cs + d_hold[ (c[0], c[1]) ][1]
l_res.append((cc,cv,cs))

l_res.sort(lambda x,y: cmp(x[1],y[1]))
l_res.reverse()

f = open("yahoo_ch.csv","wt")
for h in l_hold[:10] :
    f.write(h[0]+", "+str(h[1])+"\n")
f.write("\n")
for c in l_res :
    f.write(c[0]+", "+str(c[1])+", "+str(c[2])+"\n")
f.close()

